#!/bin/bash
if test ! -e linux-2.6.8.1.tar.bz2; then
	dialog --msgbox "Kernel 2.6.8.1 und die submount-Erweiterung werden heruntergeladen (ca. 35 MByte).\n\nDiesen Vorgang können Sie nur mit STRG-C abbrechen. Löschen Sie bei einem Abbruch unbedingt die heruntergeladenen Dateien und starten Sie das Skript erneut." 11 50
	wget http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.8.1.tar.bz2
	wget http://mesh.dl.sourceforge.net/sourceforge/submount/submount-0.9.tar.gz
fi
dialog --msgbox "Kernel-Sourcen werden jetzt nach /usr/src entpackt" 5 54
tar -xjvf linux-2.6.8.1.tar.bz2 -C /usr/src
tar -xzvf submount-0.9.tar.gz -C /usr/local/src
sleep 5
dialog --msgbox "Kernel-Sourcen werden gepatched" 5 35
patch -d /usr/src/linux-2.6.8.1 -p1 < bootsplash-3.1.4-sp3-2.6.8.1.diff
patch -d /usr/src/linux-2.6.8.1 -p1 < kernel-2.6.8.1-cd-patch-1.diff
patch -d /usr/src/linux-2.6.8.1 -p1 < kernel-2.6.8.1-cd-patch-2.diff
sleep 5
dialog --msgbox "Der Kernel wird konfiguriert.\n\nSie werden nach den Einstellungen für neue Kernel-Optionen gefragt. Drücken Sie einfach die Eingabetaste, um die vorgeschlagenen Werte zu übernehmen." 10 43
cd /usr/src/linux-2.6.8.1
zcat /proc/config.gz > .config
make oldconfig
sleep 5
dialog --msgbox "Drücken Sie die Eingabetaste, um die Installation fortzusetzen." 6 40
dialog --colors --msgbox "HINWEIS:\n\nVerändern Sie in der jetzt folgenden Kernel-Konfiguration die nachfolgenden Optionen wie folgt:\n\n\Z1Processor type and features\n[ ] Use register arguments [EXPERIMENTAL]\n\nDevice Drivers/Graphics Support/Bootsplash configuration\n[*] Bootup splash screen\Zn" 16 60
make xconfig
sleep 5
dialog --msgbox "Kernel wird kompiliert" 5 26
make prepare
make rpm
sleep 5
dialog --msgbox "Kernel wird installiert" 5 27
rpm -e --justdb $(rpm -qa | egrep kernel)
rpm -ivh /usr/src/packages/RPMS/i386/kernel-2.6.8.1-1.i386.rpm
cd ..
rm linux
ln -s linux-2.6.8.1 linux
cd /boot
mkinitrd -k vmlinuz-2.6.8.1 -i initrd-2.6.8.1
rm vmlinuz
rm initrd
ln -s vmlinuz-2.6.8.1 vmlinuz
ln -s initrd-2.6.8.1 initrd
sleep 5
dialog --colors --msgbox "ACHTUNG:\n\nDer neue Kernel wird jetzt an Stelle des alten geladen. Die Verknüpfungen \Z1/usr/src/linux\Zn, \Z1/boot/vmlinuz\Zn und \Z1/boot/initrd\n\Znzeigen jetzt auf den neuen Kernel.\n\nMöchten Sie zur Sicherheit, dass der alte Kernel weiterhin im Bootmenü zur Auswahl steht, gehen Sie vor dem Neustart des Systems unter\n\Z2YaST/System/Konfiguration des Bootloaders\Zn. Klicken Sie oben auf\n\Z2Verfügbare Abschnitte\Zn und unten auf \Z2Bearbeiten\Zn. Markieren Sie den Eintrag \Z1Linux \Znund klicken Sie auf \Z2Hinzufügen\Zn, um ihn zu Duplizieren. Geben Sie im angezeigten Dialog den gewünschten Namen an (z.B. \Z1Linux - Original SuSE-Kernel\Zn), klicken Sie auf \Z1Kernel \Znund \Z2Bearbeiten\Zn.\nÄndern Sie den Abschnitt \Z1(hd0,x)/boot/vmlinuz \Znso, dass hier der Name des alten Kernels steht, der ebenfalls im Ordner \Z1/boot \Znliegt. In Ihrem Falle sollte das \Z1(hd0,x)"$(ls /boot/vmlinuz-2.6.4*)" \Znsein.\nVerfahren Sie ebenso mit der Zeile \Z2initrd\Zn." 22 75
dialog --colors --msgbox "Starten Sie den Rechner jetzt neu mit dem neuen Kernel\nund rufen Sie nach dem Neustart das Skript \Z1install2.sh\n\Znim Ordner \Z1/usr/local/src/packages/kernel-update \Znauf, um \Z2submount \Znzu installieren.\n\Z2submount\Zn wird für die automatische Erkennung von Wechseldatenträgern benötigt und ist in dem gerade installierten Kernel nicht enthalten. Erst nach der Installation von \Z2submount \Znkönnen Sie wieder auf Wechseldatenträger wie CD oder DVD zugreifen." 13 58
